﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Collections;

namespace MPSMinCon
{
    class Problemi
    {
        internal int[][] precedenceRelationsPrSuc;
        internal int[][] precedenceRelationsPrPre;
        private int[] varguNdihmesNoAct;
        internal int[,] aModRes;
        private int[,] actModResPr;
        internal int[,] localResources;
        //internal int[,] localResources1;
        internal int[] globalResources;
        internal int[,] projectInfoPr;// = new int[6];
        private int[] horizonPr;
        //internal int[] actFunditProj;
        internal int[,] actFillFunProjaMod;// = new int[Problemi.;
        //internal int[,] Rezultati.Rezultati.actThjeshtimi;
        internal int noProjects, noResourcesTotal, noActivitiesTotal = 0, totalModesPr = 0;
        ArrayList ListaProj = new ArrayList();
        internal Dictionary<int, int[,]> DicT = new Dictionary<int, int[,]>();
        internal Dictionary<long, int[]> DicTaModes = new Dictionary<long, int[]>();

        public Problemi(System.IO.StreamReader file1)
        {
            LexoFileGlobal(file1);
            ListaProj.Clear();
            aModRes = new int[actModResPr.GetLength(0) - KtheNrModetInfeasible(), actModResPr.GetLength(1) + 1];
            EkzekutoHeqjenMOdeveInfeas();
            Rezultati.AModLen1 = aModRes.GetLength(0);
            Rezultati.AModLen2 = aModRes.GetLength(1);

            Rezultati.InicDimens();
        }

        private void LexoFileGlobal(System.IO.StreamReader file)
        {
            if (!Rezultati.MMLib)
            {
                string rreshti;
                while ((rreshti = file.ReadLine()) != null)
                {
                    int proj;
                    if (int.TryParse(rreshti, out proj)) { noProjects = proj; }
                    projectInfoPr = new int[noProjects, 6 + 2];// 2 kolonat e fundit per renresources dhe nonrenresources..
                    horizonPr = new int[noProjects];
                    for (int i = 0; i < noProjects; i++)
                    {
                        Projekti prj;
                        projectInfoPr[i, 0] = i;
                        rreshti = file.ReadLine();
                        if (int.TryParse(rreshti, out proj)) { projectInfoPr[i, 2] = proj; }

                        rreshti = file.ReadLine();
                        if (int.TryParse(rreshti, out proj)) { projectInfoPr[i, 5] = proj; }

                        rreshti = file.ReadLine();
                        prj = new Projekti(new System.IO.StreamReader(Rezultati.str + "\\" + rreshti), Rezultati.MMLib);// (@"c:\MMP\" + rreshti));
                        ListaProj.Add(prj);
                        noActivitiesTotal += prj.NoActivities;
                        totalModesPr += prj.TotalModes;
                        horizonPr[i] = prj.Horizon;
                        prj.projectInfo[0] = i;
                        projectInfoPr[i, 1] = prj.NoActivities;
                        projectInfoPr[i, 3] = projectInfoPr[i, 2] + prj.projectInfo[3];
                        projectInfoPr[i, 4] = prj.projectInfo[4];
                        projectInfoPr[i, 6] = prj.RenRes;
                        projectInfoPr[i, 7] = prj.NonRenRes;
                    }

                    actFillFunProjaMod = new int[noProjects, 2];
                    Rezultati.fillFundProjekteve = new int[noProjects, 2];
                    Rezultati.actThjeshtimi = new int[noActivitiesTotal, 3];//0-projekti, 1-no i aktivitetit ne projekt, 2-no global i aktivitetit
                    rreshti = file.ReadLine();
                    if (int.TryParse(rreshti, out proj))
                    {
                        noResourcesTotal = proj;
                        globalResources = new int[noResourcesTotal];
                        localResources = new int[noProjects, noResourcesTotal];
                        //localResources1 = new int[noProjects, noResourcesTotal];
                    }

                    rreshti = file.ReadLine();

                    rreshti = rreshti.Replace('\t', ' ');
                    string[] fjalet = rreshti.Split(' ');
                    //string[] fjalet;// = rreshti.Split('\t');

                    //if (rreshti.Contains('\t'))
                    //    fjalet = rreshti.Split('\t');
                    //else
                    //    fjalet = rreshti.Split(' ');


                    int k = 0;
                    foreach (string fj in fjalet)
                    {
                        if (int.TryParse(fj, out proj)) { if (proj != 0) globalResources[k++] = proj; }
                    }

                }
            }
            else//Rasti per SPSP
            {
                Projekti prj;
                noProjects = 1;
                projectInfoPr = new int[noProjects, 6 + 2];//
                projectInfoPr[0, 0] = 0;
                //string dokPSP;
                //string[] files = Directory.GetFiles(Rezultati.str1);
                prj = new Projekti(file, Rezultati.MMLib);//new System.IO.StreamReader(Rezultati.str + "\\" + rreshti));
                ListaProj.Add(prj);
                noActivitiesTotal = prj.NoActivities;
                totalModesPr += prj.TotalModes;
                //horizonPr[i] = prj.Horizon;
                prj.projectInfo[0] = 0;
                projectInfoPr[0, 1] = prj.NoActivities;
                projectInfoPr[0, 2] = 0;
                projectInfoPr[0, 3] = projectInfoPr[0, 2] + prj.projectInfo[3];
                projectInfoPr[0, 4] = prj.projectInfo[4];
                projectInfoPr[0, 5] = 0;
                projectInfoPr[0, 6] = prj.RenRes;
                projectInfoPr[0, 7] = prj.NonRenRes;
                //////
                actFillFunProjaMod = new int[noProjects, 2];
                Rezultati.fillFundProjekteve = new int[noProjects, 2];
                Rezultati.actThjeshtimi = new int[noActivitiesTotal, 3];//0-projekti, 1-no i aktivitetit ne projekt, 2-no global i aktivitetit

                noResourcesTotal = prj.renRes + prj.nonrenRes;//
                globalResources = new int[noResourcesTotal];
                localResources = new int[noProjects, noResourcesTotal];
                //localResources1 = new int[noProjects, noResourcesTotal];              
            }


            precedenceRelationsPrSuc = new int[noActivitiesTotal][];
            varguNdihmesNoAct = new int[noActivitiesTotal];
            actModResPr = new int[totalModesPr, 3 + noResourcesTotal];

            //actFunditProj = new int[noProjects];

            Projekti prJ = (Projekti)ListaProj[0];
            int fuN = prJ.TotalModes - 1;

            int prec = 0, act = 0, aFProj = 0;
            foreach (Projekti proj in ListaProj)
            {
                for (int i = 0; i < proj.NoActivities; i++)
                {
                    precedenceRelationsPrSuc[i + prec] = new int[proj.precedenceRelations[i].Length]; //new int[1 + proj.precedenceRelations[i].Length];
                    Rezultati.actThjeshtimi[i + prec, 0] = proj.projectInfo[0];
                    //precedenceRelationsPr[i + prec][0] = proj.projectInfo[0];

                    ///////////////////////////////////

                    for (int j = 0; j < proj.precedenceRelations[i].Length; j++)
                    {
                        if (j == 0)
                        {
                            Rezultati.actThjeshtimi[i + prec, 1] = proj.precedenceRelations[i][j]; Rezultati.actThjeshtimi[i + prec, 2] = i + prec;
                            precedenceRelationsPrSuc[i + prec][j] = i + prec;
                        }
                        else precedenceRelationsPrSuc[i + prec][j] = proj.precedenceRelations[i][j];
                    }
                }

                prec += proj.NoActivities;
                //actFunditProj[aFProj] = Rezultati.actThjeshtimi[prec - 1, 2];/////////////////////////////////////2 Prill 2015
                Rezultati.fillFundProjekteve[proj.projectInfo[0], 0] = prec - proj.NoActivities;
                Rezultati.fillFundProjekteve[proj.projectInfo[0], 1] = Rezultati.actThjeshtimi[prec - 1, 2];//fundi i projektit
                aFProj++;

                //actFillFunProjaMod[aInd,0] = fiLl;
                //actFillFunProjaMod[aInd,1] = fuN;
                //aInd++;
                //fiLl = fuN+1;
                //fuN += proj.TotalModes;
                for (int i = 0; i < proj.TotalModes; i++)
                {
                    // actModResPr[i + act, 0] = proj.projectInfo[0];
                    for (int j = 0; j < (3 + noResourcesTotal); j++)
                    {
                        if (j == 0)
                        {
                            int k = 0;
                            while (k < noActivitiesTotal)
                            {
                                if ((Rezultati.actThjeshtimi[k, 0] == proj.projectInfo[0]) && (Rezultati.actThjeshtimi[k, 1] == proj.actModRes[i, j]))
                                    actModResPr[i + act, j] = Rezultati.actThjeshtimi[k, 2];
                                k++;
                            }
                        }
                        else actModResPr[i + act, j] = proj.actModRes[i, j];
                    }

                }
                act += proj.TotalModes;
                //precedenceRelations[i] = new int[fjalet1.Length];
                for (int i = 0; i < proj.renewableRes.Length; i++)
                {
                    //{
                        localResources[proj.projectInfo[0], i] = proj.renewableRes[i];
                        //localResources1[proj.projectInfo[0], i] = proj.renewableRes[i];
                   // }
                }
                for (int i = 0; i < proj.nonrenewableRes.Length; i++)
                {
                    //{
                        localResources[proj.projectInfo[0], i + proj.renewableRes.Length] = proj.nonrenewableRes[i];
                    //    localResources1[proj.projectInfo[0], i + proj.renewableRes.Length] = proj.nonrenewableRes[i];
                    //}
                }

                if (!Rezultati.MMLib)
                {
                    for (int i = 0; i < globalResources.Length; i++)
                    {
                        if (globalResources[i] != -1) localResources[proj.projectInfo[0], i] = -1;//globalResources[i];
                    }
                }

            }

            //Adapto pasardhesit
            //PrintoMatrice(projectInfoPr);
            //Console.ReadLine();
            int zh = 0, yh = -1;
            for (int i = 0; i < noProjects; i++)
            {
                for (int j = zh; j < projectInfoPr[i, 1] + zh; j++)
                {
                    for (int k = 3; k < precedenceRelationsPrSuc[j].Length; k++)
                    {
                        precedenceRelationsPrSuc[j][k] = yh + precedenceRelationsPrSuc[j][k];
                        varguNdihmesNoAct[precedenceRelationsPrSuc[j][k]]++;
                        //Console.Write(precedenceRelationsPrSuc[j][k]+" ");
                    }
                    //Console.ReadLine();
                    //Console.WriteLine();
                }
                yh = projectInfoPr[i, 1] + zh - 1;
                zh += projectInfoPr[i, 1];
            }
            //Console.ReadLine();

            //Console.WriteLine("---------------................------");

            //Gjej aktivitetet paraardhese: precedenceRelationsPrPre{aktiviteti, koha_me_e_hershme_e_startimit, lista_e_paradhesve} 
            precedenceRelationsPrPre = new int[noActivitiesTotal][];
            Rezultati.precRelationsPrPre = new bool[noActivitiesTotal][];

            for (int i = 0; i < varguNdihmesNoAct.Length; i++)
            {
                precedenceRelationsPrPre[i] = new int[varguNdihmesNoAct[i] + 3];
                Rezultati.precRelationsPrPre[i] = new bool[varguNdihmesNoAct[i]];
                precedenceRelationsPrPre[i][2] = i;
            }
            //PrintoMatrice1(precedenceRelationsPrPre);
            //Console.ReadLine();
            zh = 0;
            for (int i = 0; i < noProjects; i++)
            {
                for (int j = zh; j < projectInfoPr[i, 1] + zh; j++)
                {
                    precedenceRelationsPrPre[j][0] = projectInfoPr[i, 0];
                    precedenceRelationsPrPre[j][1] = projectInfoPr[i, 2];
                    for (int k = 3; k < precedenceRelationsPrSuc[j].Length; k++)
                    {
                        int u = 3;
                        while (precedenceRelationsPrPre[precedenceRelationsPrSuc[j][k]][u] != 0)
                            u++;
                        precedenceRelationsPrPre[precedenceRelationsPrSuc[j][k]][u] = precedenceRelationsPrSuc[j][0];
                        // Console.Write(precedenceRelationsPrPre[precedenceRelationsPrSuc[j][k]][u] + " ");
                    }
                    //Console.ReadLine();
                }
                zh += projectInfoPr[i, 1];
            }
            // PrintoMatrice1(precedenceRelationsPrPre);
            //Console.ReadLine();

        }

        private int KtheNrModetInfeasible()
        {
            int projID = -1, numeroInfeasibleModet = 0;
            //int[,] aModRes;
            for (int i = 0; i < actModResPr.GetLength(0); i++)
            {
                // actModResPr[i + act, 0] = proj.projectInfo[0];
                int prId = Rezultati.actThjeshtimi[actModResPr[i, 0], 0];
                if (prId != projID) projID = prId;

                int nrLocRes = localResources.GetLength(1);//problemiObj.projectInfoPr[aModRes[j, aModRes.GetLength(1) - 1], 6];
                for (int k = 0; k < nrLocRes; k++)
                {
                    //nonreslocal[aModRes[j, aModRes.GetLength(1) - 1], k] += 
                    if (localResources[projID, k] < actModResPr[i, k + 3])
                    {
                        if (localResources[projID, k] != -1)
                        {
                            precedenceRelationsPrSuc[actModResPr[i, 0]][1]--;
                            actModResPr[i, 0] = -1;
                            numeroInfeasibleModet++;
                            break;
                        }
                    }
                }
                //else actModResPr[i + act, j] = proj.actModRes[i, j];//ketu validimi per modet infeasible                   
            }

            return numeroInfeasibleModet;

        }

        private void EkzekutoHeqjenMOdeveInfeas()
        {
            int i = 0, k = 0, l = 0;//, projID = -1;
            //for (int i = 0; i < actModResPr.GetLength(0); i++)
            int projID = Rezultati.actThjeshtimi[actModResPr[0, 0], 0];
            actFillFunProjaMod[projID, 0] = 0;// fiLl;
            //actFillFunProjaMod[aInd, 1] = fuN;
            int[,] vargDict = new int[2, 2];
            int[] vAM = new int[actModResPr.GetLength(1) - 2];
            int act = -1, nrModA = -1;//, dimenVarg;
            DicT.Clear();
            DicTaModes.Clear();
            //bool KaFillu = false;
            //while (actModResPr[i, 0] == -1) i++;

            //act = -1;// actModResPr[i, 0];
            //nrModA = precedenceRelationsPrSuc[i][1];
            //if (nrModA == 1) 
            //{
            //    vargDict = new int[2, actModResPr.GetLength(1) - 1];//nrModA+1, actModResPr.GetLength(1) - 1];
            //}
            //else vargDict = new int[nrModA, actModResPr.GetLength(1) - 1];
            //dimenVarg = 0;

            while (i < actModResPr.GetLength(0))
            {
                //aModRes[i, aModRes.GetLength(1) - 1] = problemiObj.Rezultati.actThjeshtimi[aModRes[i, 0], 0];j//
                //if (i >= actModResPr.GetLength(0) - 2) Console.WriteLine();/////
                if (actModResPr[i, 0] != -1)
                {
                    if (actModResPr[i, 0] != act)
                    {
                        if (act != -1)
                        {
                            if (!DicT.ContainsKey(act))
                            {
                                DicT.Add(act, vargDict);
                                //int[] vAplusModes = { act, modi };
                                //DicTaModes.Add(vAplusModes, vAM);
                            }
                        }

                        act = actModResPr[i, 0];
                        //modi = actModResPr[i, 1];
                        nrModA = precedenceRelationsPrSuc[act][1];
                        if (nrModA == 1)
                        {
                            vargDict = new int[2, actModResPr.GetLength(1) - 1];//nrModA+1, actModResPr.GetLength(1) - 1];
                        }
                        else vargDict = new int[nrModA, actModResPr.GetLength(1) - 1];


                        l = 0;
                        //dimenVarg = 1;//kontrolloje..........
                    }// act == actModResPr[i, 0]) dimenVarg++;                   
                    //////////////
                    vAM = new int[actModResPr.GetLength(1) - 2];
                    int m = 0, n = 0;
                    for (int j = 0; j < actModResPr.GetLength(1); j++)
                    {
                        aModRes[k, j] = actModResPr[i, j];
                        if (j > 0) { vargDict[l, m] = actModResPr[i, j]; m++; }
                        if (j > 1) { vAM[n] = actModResPr[i, j]; n++; }
                    }
                    Rezultati.vDct[0] = actModResPr[i, 0];//, actModResPr[i, 1]};
                    Rezultati.vDct[1] = actModResPr[i, 1];
                    long dsd = (Rezultati.vDct.GetHashCode() + Rezultati.vDct[0] * 1000 + Rezultati.vDct[1]).GetHashCode();
                    if (!DicTaModes.ContainsKey(dsd))
                    {
                        // DicT.Add(act, vargDict);                       
                        DicTaModes.Add(dsd, vAM);
                    }
                    l++;
                    //if (Rezultati.actThjeshtimi[actModResPr[i, 0], 0] > 0) Console.WriteLine();
                    aModRes[k, aModRes.GetLength(1) - 1] = Rezultati.actThjeshtimi[actModResPr[i, 0], 0];

                    int prId = Rezultati.actThjeshtimi[aModRes[k, 0], 0];
                    if (prId != projID)
                    {
                        actFillFunProjaMod[projID, 1] = k - 1;
                        actFillFunProjaMod[prId, 0] = k;
                        projID = prId;
                        //if (k >= aModRes.GetLength(0)-1) Console.WriteLine();
                    }
                    k++;
                    if (k == aModRes.GetLength(0) - 1) actFillFunProjaMod[projID, 1] = k;//Console.WriteLine();
                }
                i++;
            }
            //if (!DicT.ContainsKey(act)) DicT.Add(act, vargDict);
            if (!DicT.ContainsKey(act))
            {
                DicT.Add(act, vargDict);
                //int[] vAplusModes = { act, modi };
                //DicTaModes.Add(vAplusModes, vAM);
            }
        }

    }

}

class Projekti
{
    internal int[][] precedenceRelations;
    internal int[,] actModRes;
    internal int[] renewableRes;
    internal int[] nonrenewableRes;
    internal int[] projectInfo = new int[6];
    private int horizon, totalModes = 0;
    internal int renRes, nonrenRes, noActivities;

    internal int RenRes
    {
        get { return renRes; }
        // set { renRes = value; }
    }

    internal int NonRenRes
    {
        get { return nonrenRes; }
        // set { nonrenRes = value; }
    }
    internal int Horizon
    {
        get { return horizon; }
    }

    internal int NoActivities
    {
        get { return noActivities; }
    }

    internal int TotalModes
    {
        get { return totalModes; }
    }

    public Projekti(System.IO.StreamReader file1, bool rezultati)
    {
        if (rezultati)
            LexoTeDhenatPSP(file1);
        else
            LexoTeDhenat(file1);
    }

    private void LexoTeDhenat(System.IO.StreamReader file)
    {
        int indeksi = 1;
        string rreshti;
        while ((rreshti = file.ReadLine()) != null)
        {
            rreshti = rreshti.Replace('\t', ' ');
            string[] fjalet = rreshti.Split(' ');

            //string[] fjalet = rreshti.Split(' ');
            //if (rreshti.Contains(' '))
            //    fjalet = rreshti.Split(' ');
            //else
            //    fjalet = rreshti.Split('\t');
            if (indeksi == 6)
            {
                int act;
                foreach (string fj in fjalet)
                {
                    if (int.TryParse(fj, out act)) { noActivities = act; precedenceRelations = new int[noActivities][]; }
                }
            }
            else if (indeksi == 7)
            {
                int horiz;
                foreach (string fj in fjalet)
                {
                    if (int.TryParse(fj, out horiz)) { horizon = horiz; }
                }
            }
            if (indeksi == 9)
            {
                int rres;
                foreach (string fj in fjalet)
                {
                    if (int.TryParse(fj, out rres)) { renRes = rres; renewableRes = new int[renRes]; }
                }
            }
            else if (indeksi == 10)
            {
                int nrres;
                foreach (string fj in fjalet)
                {
                    if (int.TryParse(fj, out nrres)) { nonrenRes = nrres; nonrenewableRes = new int[nonrenRes]; }
                }
            }
            else if (indeksi == 15)
            {
                int ind = 0, nr;
                foreach (string fj in fjalet)
                {
                    if (int.TryParse(fj, out nr)) { projectInfo[ind] = nr; ind++; }
                }
            }
            else if (indeksi == 19)
            {

                for (int i = 0; i < noActivities; i++)
                {
                    string[] fjalet1 = HicZbrazetirat(rreshti);//.Split(' '));
                    int ind = 0, nr;
                    precedenceRelations[i] = new int[fjalet1.Length];
                    foreach (string fj in fjalet1)
                    {
                        if (int.TryParse(fj, out nr)) { precedenceRelations[i][ind] = nr; ind++; }
                    }
                    rreshti = file.ReadLine();
                    indeksi++;
                }


                for (int i = 0; i < noActivities; i++)
                {
                    totalModes += precedenceRelations[i][1];
                }


                actModRes = new int[totalModes, (3 + renRes + nonrenRes)];

                for (int i = 0; i < 4; i++)
                {
                    rreshti = file.ReadLine();
                    indeksi++;
                }
                //
                for (int i = 0; i < totalModes; i++)
                {
                    string[] fjalet1 = HicZbrazetirat(rreshti);//.Split(' '));
                    int ind = 0, nr;
                    if (fjalet1.Length < (3 + renRes + nonrenRes)) { actModRes[i, 0] = 0; ind++; }
                    foreach (string fj in fjalet1)
                    {

                        if (int.TryParse(fj, out nr))
                        {
                            actModRes[i, ind] = nr;
                            ind++;
                        }
                    }
                    rreshti = file.ReadLine();
                    indeksi++;
                }

                int kntr = actModRes[1, 0];
                for (int i = 1; i < totalModes; i++)
                {
                    while ((actModRes[i, 0] == 0) && (i < totalModes))
                    {
                        actModRes[i, 0] = kntr;
                        i++;
                    }
                    kntr = actModRes[i, 0];
                }
                //
                for (int i = 0; i < 3; i++)
                {
                    rreshti = file.ReadLine();
                    indeksi++;
                }
                //
                string[] fjalet2 = HicZbrazetirat(rreshti);//.Split(' '));
                int ind1 = 0, nr1; //dimens = renRes;//renewableRes.Length;

                foreach (string fj in fjalet2)
                {
                    if (int.TryParse(fj, out nr1))
                    {
                        if (ind1 < renRes)
                            renewableRes[ind1] = nr1;
                        else
                            nonrenewableRes[ind1 - renRes] = nr1;
                        ind1++;
                    }
                }
            }

            indeksi++;
        }
    }

    private void LexoTeDhenatPSP(System.IO.StreamReader file)
    {
        int indeksi = 1;
        string rreshti;
        while ((rreshti = file.ReadLine()) != null)
        {
            rreshti = rreshti.Replace('\t', ' ');
            string[] fjalet = rreshti.Split(' ');
            //if (rreshti.Contains(' '))
            //    fjalet = rreshti.Split(' ');
            //else
            //    fjalet = rreshti.Split('\t');

            if (indeksi == 1)
            {
                int act;
                foreach (string fj in fjalet)
                {
                    if (int.TryParse(fj, out act)) { noActivities = act; precedenceRelations = new int[noActivities][]; }
                }
            }
            else if (indeksi == 3)
            {
                int rres;
                foreach (string fj in fjalet)
                {
                    if (int.TryParse(fj, out rres)) { renRes = rres; renewableRes = new int[renRes]; }
                }
            }
            else if (indeksi == 4)
            {
                int nrres;
                foreach (string fj in fjalet)
                {
                    if (int.TryParse(fj, out nrres)) { nonrenRes = nrres; nonrenewableRes = new int[nonrenRes]; }
                }
            }
            else if (indeksi == 9)
            {

                for (int i = 0; i < noActivities; i++)
                {
                    string[] fjalet1 = HicZbrazetirat(rreshti);//.Split(' '));
                    int ind = 0, nr;
                    precedenceRelations[i] = new int[fjalet1.Length];
                    foreach (string fj in fjalet1)
                    {
                        if (int.TryParse(fj, out nr)) { precedenceRelations[i][ind] = nr; ind++; }
                    }
                    rreshti = file.ReadLine();
                    indeksi++;
                }


                for (int i = 0; i < noActivities; i++)
                {
                    totalModes += precedenceRelations[i][1];
                }


                actModRes = new int[totalModes, (3 + renRes + nonrenRes)];

                for (int i = 0; i < 4; i++)
                {
                    rreshti = file.ReadLine();
                    indeksi++;
                }
                //
                for (int i = 0; i < totalModes; i++)
                {
                    string[] fjalet1 = HicZbrazetirat(rreshti);//.Split(' '));
                    int ind = 0, nr;
                    if (fjalet1.Length < (3 + renRes + nonrenRes)) { actModRes[i, 0] = 0; ind++; }
                    foreach (string fj in fjalet1)
                    {

                        if (int.TryParse(fj, out nr))
                        {
                            actModRes[i, ind] = nr;
                            ind++;
                        }
                    }
                    rreshti = file.ReadLine();
                    indeksi++;
                }

                int kntr = actModRes[1, 0];
                for (int i = 1; i < totalModes; i++)
                {
                    while ((actModRes[i, 0] == 0) && (i < totalModes))
                    {
                        actModRes[i, 0] = kntr;
                        i++;
                    }
                    kntr = actModRes[i, 0];
                }
                //
                //rreshti = file.ReadLine();
                for (int i = 0; i < 3; i++)
                {
                    rreshti = file.ReadLine();
                    if ((rreshti == "") || (rreshti == " ")) i--;
                    indeksi++;
                }
                //
                string[] fjalet2 = HicZbrazetirat(rreshti);//.Split(' '));
                int ind1 = 0, nr1; //dimens = renRes;//renewableRes.Length;

                foreach (string fj in fjalet2)
                {
                    if (int.TryParse(fj, out nr1))
                    {
                        if (ind1 < renRes)
                            renewableRes[ind1] = nr1;
                        else
                            nonrenewableRes[ind1 - renRes] = nr1;
                        ind1++;
                    }
                }
            }

            indeksi++;
        }
    }


    public string[] HicZbrazetirat(string rreshti)//string[] str)
    {
        //string[] strOut;
        //int numero = 0;
        //for (int i = 0; i < str.Length; i++)
        //    if (str[i] != "") numero++;

        //strOut = new string[numero];
        //int j = 0;
        //for (int i = 0; i < str.Length; i++)
        //    if (str[i] != "") { strOut[j] = str[i]; j++; }
        //return strOut;
        string[] str;
        rreshti = rreshti.Replace('\t', ' ');
        str = rreshti.Split(' ');
        string[] strOut;
        int numero = 0;
        for (int i = 0; i < str.Length; i++)
            if (str[i] != "") numero++;

        strOut = new string[numero];
        int j = 0;
        for (int i = 0; i < str.Length; i++)
            if (str[i] != "") { strOut[j] = str[i]; j++; }
        return strOut;
    }
}
