﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Collections;
using System.Threading;
using System.IO;

namespace MPSMinCon
{
    class SearchMethod
    {
        //private static System.Timers.Timer aTimer;
        private static string emstr;
        private Solution[] solObj;
        
        private void MbaroProgramin(Object source, System.Timers.ElapsedEventArgs e)
        {
            int maksi, indks;
            Rezultati.KtheMax(out maksi, out indks, solObj);
            int kt = 0;
            bool KaP = false;
            KaP = Rezultati.AcceptanceCriterion(maksi, indks, ref KaP, ref kt, solObj);
            Console.WriteLine("Final result: " + Rezultati.deltaF + " " + DateTime.Now);
            if(Rezultati.MMLib)
                Rezultati.ShkruajNeFilePSP(emstr);
            else
                Rezultati.ShkruajNeFile(emstr);            
            Environment.Exit(0);
        }

        public void GjejZgjidhje(string str, string emrstr)
        {
            emstr = emrstr;
            int PertSizeThreshold = 1;
            bool Improvement = false;
            //Random random = new Random(Guid.NewGuid().GetHashCode());
            //double rnd = random.NextDouble();
            solObj = new Solution[4];
            for (int i = 0; i < solObj.Length; i++)
            {
                solObj[i] = new Solution(str);
            }          
            Thread[] th = new Thread[4];
            for (int i = 0; i < 4; i++)
            {
                int j = i;
                th[i] = new Thread(() => solObj[j].GenerateInitSolution());
                th[i].Start();
            }
            for (int i = 0; i < 4; i++)
            {
                th[i].Join();
            }
        
            solObj[0].InicializoRezultatin();           
            Rezultati.deltaF = solObj[0].Funksioni_ObjFinal();//
            Rezultati.Kopjo(solObj[0].rendAct, Rezultati.rezultati); 
            Rezultati.Kopjo(Rezultati.rezultati, Rezultati.rezultatiPerfundimtar);
                     
            //Console.WriteLine("Initial solution: " + Rezultati.deltaF);//         
            Console.WriteLine("Working...");
            int timeMili = Rezultati.nrSec * 1000;
            ////aTimer = new System.Timers.Timer(timeMili);
            ////aTimer.Elapsed += MbaroProgramin;
            ////aTimer.AutoReset = false;
            ////aTimer.Enabled = true;

            ////Te hiqet
            DateTime dt1 = new DateTime();
            DateTime dt = new DateTime();
            dt = DateTime.Now;
            //dt1 = DateTime.Now;            
            dt1 = dt.AddMilliseconds(timeMili);//  

            bool LocalImprovement = true;              
            bool InitImprove = true;
            bool alterO = true;
           
            while ((InitImprove) && (DateTime.Now < Rezultati.initDt))
            {
                InitImprove = false;
                for (int i = 0; i < 4; i++)
                {
                    int j = i;
                    th[i] = new Thread(() => solObj[j]._InitTMC(ref InitImprove, j + 1));
                    th[i].Start();
                }
                for (int i = 0; i < 4; i++)
                {
                    th[i].Join();
                }

                if (InitImprove)
                {
                    int maksi00, indks00;
                    Rezultati.KtheMax(out maksi00, out indks00, solObj);
                    Rezultati.AcceptanceCriterion(indks00, solObj, maksi00);

                    if (alterO)
                    {
                        for (int i = 0; i < 4; i++)
                        {
                            int j = i;
                            th[i] = new Thread(() => solObj[j]._PCOM());
                            th[i].Start();
                        }

                        for (int i = 0; i < 4; i++)
                        {
                            th[i].Join();
                        }
                        alterO = false;
                    }
                }             
            }
          
            int cnt = 0;   
            while (!Rezultati.Over)
            {
                Rezultati.Reseto(solObj);
                Improvement = true;               
                while (Improvement)
                {
                    th[0] = new Thread(() => solObj[0]._ComE(true));
                    th[1] = new Thread(() => solObj[1]._ComF(true));
                    th[2] = new Thread(() => solObj[2]._ComE(false));
                    th[3] = new Thread(() => solObj[3]._ComF(false));
                    for (int i = 0; i < 4; i++)
                    {
                        th[i].Start();
                    }
                    for (int i = 0; i < 4; i++)
                    {
                        th[i].Join();
                    }
                    int maksi, indks;
                    Rezultati.KtheMax(out maksi, out indks, solObj);
                    Improvement = Rezultati.AcceptanceCriterion(maksi, indks, ref Improvement, ref PertSizeThreshold, solObj);
                    if (Improvement) LocalImprovement = true;

                    ////Te hiqet
                    if (DateTime.Now >= dt1) Rezultati.Over = true;
                }//while 

                if (LocalImprovement) 
                {
                    InitImprove = true;
                    while (InitImprove)
                    {
                        InitImprove = false;
                        for (int i = 0; i < 4; i++)
                        {
                            int j = i;
                            th[i] = new Thread(() => solObj[j]._MinConOMC(ref InitImprove));                        
                            th[i].Start();
                        }
                        for (int i = 0; i < 4; i++)
                        {
                            th[i].Join();
                        }

                        if (InitImprove)
                        {
                            int maksi00, indks00;
                            Rezultati.KtheMax(out maksi00, out indks00, solObj);
                            Rezultati.AcceptanceCriterion(indks00, solObj, maksi00);
                        }
                    }

                    for (int i = 0; i < 4; i++)
                    {
                        int j = i;
                        th[i] = new Thread(() => solObj[j]._PCOM());
                        th[i].Start();
                    }

                    for (int i = 0; i < 4; i++)
                    {
                        th[i].Join();
                    }
                 
                        for (int i = 0; i < 4; i++)
                        {
                            int j = i;
                            th[i] = new Thread(() => solObj[j]._MinConTMC());
                            th[i].Start();
                        }                                      
                    cnt++;
                }
                else 
                {
                    //if (DateTime.Now > Rezultati.altDt)
                    //{
                    //    for (int i = 0; i < 4; i++)
                    //    {
                    //        th[i].Join();
                    //    }
                    //    for (int i = 0; i < 4; i++)
                    //    {
                    //        int j = i;
                    //        th[i] = new Thread(() => solObj[j]._MinConFMC(j+1));
                    //        th[i].Start();
                    //    }
                    //}

                    if (cnt % 2 == 0)
                    {
                        for (int i = 0; i < 4; i++)
                        {
                            int j = i;
                            if (j % 2 == 0)
                                th[i] = new Thread(() => solObj[j]._MinConSJL());
                            else
                                th[i] = new Thread(() => solObj[j]._MinConSJR());
                            th[i].Start();
                        }
                    }
                    else
                    {
                        for (int i = 0; i < 4; i++)
                        {
                            int j = i;
                            if (j % 2 == 0)
                                th[i] = new Thread(() => solObj[j]._MinConSJR());
                            else
                                th[i] = new Thread(() => solObj[j]._MinConSJL());
                            th[i].Start();
                        }
                    }               
                       
                    //    if (cnt % 4 == 0)
                    //    {
                    //        for (int i = 0; i < 4; i++)
                    //        {
                    //            th[i].Join();
                    //        }
                    //        for (int i = 0; i < 4; i++)
                    //        {
                    //            int j = i;
                    //            th[i] = new Thread(() => solObj[j]._INVS());
                    //            th[i].Start();
                    //        }                           
                    //    }                        
                }

                for (int i = 0; i < 4; i++)
                {
                    th[i].Join();
                }
                int maksi0, indks0;
                Rezultati.KtheMax(out maksi0, out indks0, solObj);
                Improvement = Rezultati.AcceptanceCriterion(maksi0, indks0, ref Improvement, ref PertSizeThreshold, solObj);
                if (Improvement) { LocalImprovement = true;}
                else
                {                   
                    LocalImprovement = !LocalImprovement; PertSizeThreshold++; 
                }
                ////Te hiqet
                if (DateTime.Now >= dt1) Rezultati.Over = true;

                for (int i = 0; i < 4; i++)
                {
                    int j = i;
                    th[i] = new Thread(() => solObj[j].Perturbate(PertSizeThreshold));
                    th[i].Start();
                }
                for (int i = 0; i < 4; i++)
                {
                    th[i].Join();
                }                
            }

            Console.WriteLine("Result: " + Rezultati.deltaF);
            using (StreamWriter sw = File.AppendText(Rezultati.str + "\\Result.txt"))
            {
                sw.Write("{0, -16}", Rezultati.deltaF);
                sw.WriteLine();
            }
            if(Rezultati.MMLib)
                Rezultati.ShkruajNeFilePSP(emrstr);
            else
            Rezultati.ShkruajNeFile(emrstr);           
        }
    }
}
